#include <cstdlib> 
#include <iostream>
using namespace std;

//     ============>  
//    -|-    |     |
//   --|--   |     |
//  ---|---  |     |
//     1     2     3 

int nopr = 0;                     // счётчик операций

// собственно перенос 1-го кольца с from на to 
void put( int from, int to ) {
   cout << from << " => " << to << " | ";
   if( 0 == ( ++nopr % 5 ) ) cout << endl;
}

// перенос с позиции from на позицию to n колец:
void move( int from, int to, int n ) {
   int temp = from ^ to;          // промежуточная позиция
   if( 1 == n ) put( from, to );  // перенести это единственное кольцо
   else {
      move( from, temp, n - 1 );  // перенести n-1 верхних на temp
      put( from, to );            // перенести самое нижнее на to
      move( temp, to, n - 1 );    // поместить n-1 с temp на to 
   }
}

int main( int argc, char **argv, char **envp ) {
   int n = 5;                     // число переносимых фишек
   if( argc > 1 && atoi( argv[ 1 ] ) != 0 )
      n = atoi( argv[ 1 ] );   
   cout << "размер пирамиды: " << n << endl; 
   move( 1, 3, n );               // вот вам и всё решение!
   if( 0 != ( nopr % 5 ) ) cout << endl;
   cout << "общее число перемещений " << nopr << endl; 
   return 0;
}
