#include <assert.h>
#include <iostream>

using namespace std;

double power( double a, int n, int& m ) {
   assert( n > 0 || ( a != 0.0 || n != 0 ) );
   switch( n ) {
      case 0:
         return 1;
      case 1:
         return a;
      default : {
         double a2 = power( a, n / 2, m );
         if( n & 1 ) {
            m += 2;
            return a * a2 * a2;
         }
         else {
            m++;
            return a2 * a2;
         }
      }
   }
}

int main() {
   double e, r;
   int n, m;
   while( true ) {
      cout << "что возводить? : ";
      cin >> e;
      cout << "в какую степень? : ";
      cin >> n;
      m = 0;
      r = power( e, n, m );
      cout << e << "**" << n << "=" << r << ", число умножений " << m << endl;
   }
}