#include <iostream>
#include <iomanip>
#include <cstring>
#include <cstdio>
using namespace std;

inline char simb( unsigned val ) {
   return val < 10 ? '0' + val : 'A' + val - 10;
}

string show( int arr[],         // только для отладки
             unsigned size ) {
   char str[ 1000 ];
   strcpy( str, "{ ");
   for( unsigned i = 0; i < size; i++ )
      if( arr[ i ] < 0 ) strcat( str, ". " );
      else sprintf( str + strlen( str ), "%u ",  arr[ i ] );
   strcat( str, "}" );
   return string( str );
}

int main( int argc, char **argv ) {
   bool debug = ( argc > 1 &&
                  ( ( string( argv[ 1 ] ) == "-v" ) ||
                    ( string( argv[ 1 ] ) == "debug" )
                ) );
   while( true ) {
      int metr;
      cout << "система счисления: ";
      cin >> metr;
      unsigned ch, zn;
      cout << "числитель: ";
      cin >> ch;
      cout << "знаменатель: ";
      cin >> zn;
      if( ch >= zn ) {
         cout << "должнв быть правльная дробь!" << endl;
         continue;
      }
      string sval;
      unsigned ost = ch;
      int *list = new int [ zn ];
      for( unsigned i = 0; i < zn; i++ ) list[ i ] = -1;
      for( unsigned i = 0; i < zn; i++, ost *= metr ) {
         if( sval.empty() ) sval = "0.";
         else sval.push_back( simb( ost / zn ) );
         ost %= zn;
         if( debug ) cout << setw( 3 ) << ost << " -> " << show( list, zn ) << endl;
         if( 0 == ost ) break;
         if( list[ ost ] < 0 ) 
            list[ ost ] = i;
         else {
            ost = i - list[ ost ];
            break; 
         }
      };
      delete [] list;
      if( ost != 0 ) { // периодическая дробь, ost - период
         string::iterator is = sval.end() - ost;
         sval.insert( is, '(' );
         sval += ")";
      }
      cout << "длина периода " << ost << " : "
           << ch << " / " << zn << " = " << sval << endl;
   }
}
