#include <iostream>
#include <locale>
using namespace std;

int main( int argc, char *argv[] ) {
   bool debug = argc > 1 && "debug" == string( argv[ 1 ] );
   locale::global( locale( "" ) );
   while( 1 ) {
      wcout << L"Введите тестируемую строку : ";
      wstring w( L"\n" );
      getline( wcin, w );
      if( debug ) wcout << L"[" << w.size() << L"]: " << w << endl;
      bool poli;
      wchar_t *s = (wchar_t*)w.c_str(),
              *pb = s, *pe = pb + wcslen( s ) - 1;
      do {
         while( *pb == ' ' ) pb++;
         while( *pe == ' ' ) pe--;
         poli = towlower( *pb ) == towlower( *pe );
         if( debug ) wcout << *pb << " ? " << *pe << " = " << ( poli ? "+" : "-" )<< endl;
      } while( poli && ++pb <= --pe );
      wcout << L"строка " << ( poli ? L"" : L"не " ) << L"палиндром" << endl; 
   }
}
