#include <iostream>
#include <sstream>
using namespace std;

// гипотеза Коллатца 
void collatz( unsigned long val ) {
   cout << val << " => [";
   while( true ) {
      val = val & 1 ? 3 * val + 1 : val >> 1;
      cout << val << ( val > 1 ? "," : "]\n" );
      if( 1 == val ) return;
   }
}

int main() {
   string e;
   unsigned long d;
   while( true ) {
      cout << "Вводите натуральные числа: ";
      getline( cin, e );
      istringstream ist( e );
      while( ist >> d ) 
        collatz( d );
   }
}
