#include <cstdlib> 
#include <iostream>
#include <fstream>
#include <vector>
#include <limits>
using namespace std;

vector<double> input( char *file ) {
   double data;
   vector<double> arr;
   if( file != NULL ) {
      ifstream fin;
      fin.open( file );
      if( !fin ) {
         cerr << "ошибка открытия " << file << endl;
         exit( 1 );
      }
      while( true ) {
         fin >> data;
         if( fin.eof() ) break;
         arr.push_back( data );
      }
      fin.close();
   }
   else {
      cout << "вводите числа через пробел (Enter + ^D для завершения):" << endl;
      while( true ) {
         cin >> data;
         if( cin.eof() ) break;
         arr.push_back( data );
      }
   }
   return arr;
}

int main( int argc, char **argv, char **envp ) {
   vector<double> arr = input( argv[ 1 ] );
   cout << "массив [" << arr.size() << "]: ";
   for( vector<double>::iterator i = arr.begin(); i != arr.end(); i++ )
      cout << *i << " ";
   cout << endl;
   double suma = -numeric_limits<double>::max();
   uint nb = -1, ne = -1;
   for( uint ib = 0; ib < arr.size(); ib++ )
      for( uint ie = 0; ie < arr.size(); ie++ ) {
         double loc = 0.;
         for( uint j = ib; j <= ie; j++ )
            loc += arr[ j ];
         if( loc > suma ) {
            suma = loc;
            nb = ib;
            ne = ie;
         }
      }
   cout << "максимальная сумма " << suma << ": ";
   for( uint j = nb; j <= ne; j++ )
      cout << arr[ j ] << " ";
   cout << endl;
   return 0;
}

